<style src="./Report.scss" lang="scss" scoped></style>
<script src="./Report.js"></script>

<template>
  <div class="m-content mt-3 mt-lg-0">
    <div class="selector-attributes-report d-flex">
      <div class="position-relative">
        <div
          class="range-options select-range d-md-none d-lg-block d-xxl-none h-100"
          style="cursor: pointer"
        >
          <div
            class="m-dropdown m-dropdown--arrow m-dropdown--align-left h-100"
            m-dropdown-toggle="click"
          >
            <div class="m-dropdown__toggle d-flex align-items-center h-100 px-3">
              {{ selectedRangeOption }}
              <i
                class="icon icon-down-arrow-1 ml-auto"
                style="font-size: 8px"
              ></i>
            </div>
            <div class="m-dropdown__wrapper" style="width: 180px">
              <div class="m-dropdown__inner">
                <div class="m-dropdown__body">
                  <div
                    v-for="(option, index) in utils.objectValues(rangeOptions)"
                    :key="index"
                    class="m-dropdown__body_item"
                    :class="{ 'active': selectedRangeOption === option }"
                    @click="selectedRangeOption = option; onChangeRange()"
                  >
                    {{ option }}
                    <i class="fas fa-check"></i>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="range-options d-none d-md-flex d-lg-none d-xxl-flex">
          <div
            v-for="(option, index) in utils.objectValues(rangeOptions)"
            :key="index"
            class="range-option"
            :class="{ 'selected': selectedRangeOption === option, 'border-left-0': isRemoveBorder(index) }"
            @click="selectedRangeOption = option; onChangeRange()"
          >
            {{ option }}
            <template></template>
          </div>
        </div>
        <date-picker
          class="datepicker"
          name="rangeDatepicker"
          :lang="lang"
          range
          @change="onChange($event)"
        ></date-picker>
      </div>
      <div
        class="m-portlet__nav-item m-dropdown m-dropdown--inline m-dropdown--arrow m-dropdown--align-right m-dropdown--align-push"
        m-dropdown-toggle="click"
        aria-expanded="true"
      >
        <a
          href="#"
          class="m-portlet__nav-link m-portlet__nav-link--icon m-dropdown__toggle m--top-action nt-button nt-button-top nt-button-primary m-portlet__nav-item m-0"
        >
          <i class="icon icon-settings"></i>
          Cài đặt báo cáo
        </a>
        <div class="m-dropdown__wrapper" style="width: 280px; margin-right: 0;">
          <span class="m-dropdown__arrow m-dropdown__arrow--right m-dropdown__arrow--adjust"></span>
          <div class="m-dropdown__inner">
            <div class="m-dropdown__body p-0">
              <div class="d-flex align-items-center report-settings_tab">
                <div
                  class="setting-tab h-100 d-flex align-items-center justify-content-center"
                  @click="selectedTab = tabs.report"
                >
                  <div :class="{ 'active': selectedTab === tabs.report }">Tùy chỉnh báo cáo</div>
                </div>
                <div
                  class="setting-tab h-100 d-flex align-items-center justify-content-center"
                  :class="{ 'active': selectedTab === tabs.statistic }"
                  @click="selectedTab = tabs.statistic"
                >
                  <div :class="{ 'active': selectedTab === tabs.statistic }">Hiển thị thống kê</div>
                </div>
              </div>
              <div class="m-dropdown__content" style="position: relative;">
                <template v-if="selectedTab === tabs.report">
                  <Loading :is_loader="isLoader" />
                  <div v-for="(attribute, index) in attributeDealUsingReports" :key="index">
                    <template
                      v-if="attributeDealUsingReports && attributeDealUsingReports.length > 0"
                    >
                      <label
                        class="m-checkbox m-checkbox--primary"
                        :class="{'m-0': index === attributeDealUsingReports.length - 1}"
                      >
                        <input
                          v-model="attributesReportCheckedIds"
                          type="checkbox"
                          checked
                          :value="attribute.id"
                          @change="checkedAttributeShowHide(attribute.id)"
                        />
                        <span></span>
                        {{ attribute.attribute_name }}
                      </label>
                    </template>
                  </div>
                </template>
                <template v-else>
                  <div>
                    <label class="m-radio m-radio--primary">
                      <input
                        name="statOptions"
                        type="radio"
                        :value="statOptions.reportWithCancelStatus"
                        v-model="selectedStatOptions"
                        @change="onRefresh()"
                      />
                      <span></span>
                      {{ statOptions.reportWithCancelStatus }}
                    </label>
                  </div>
                  <div>
                    <label class="m-radio m-radio--primary">
                      <input
                        name="statOptions"
                        type="radio"
                        :value="statOptions.reportWithoutCancelStatus"
                        v-model="selectedStatOptions"
                        @change="onRefresh()"
                      />
                      <span></span>
                      {{ statOptions.reportWithoutCancelStatus }}
                    </label>
                  </div>
                </template>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div>
      <div
        v-if="isLoader"
        style="position: fixed;left: 0px;top: 60px;width: 100%;height: calc(100% - 60px);background: #ffffff8a;z-index: 12;"
      >
        <div
          class="m-loader m-loader--brand m-loader--lg"
          style="width: 30px; height: 30px; display: inline-block; position:absolute; left:50%; top:50%; transform: translate(-50%, -50%);"
        ></div>
      </div>
      <div v-else>
        <TopStats :data="topReports"></TopStats>
      </div>
    </div>
    <div>
      <div
        v-if="loadingDataChart"
        style="position: fixed;left: 0px;top: 60px;width: 100%;height: calc(100% - 60px);background: #ffffff8a;z-index: 12;"
      >
        <div
          class="m-loader m-loader--brand m-loader--lg"
          style="width: 30px; height: 30px; display: inline-block; position:absolute; left:50%; top:50%; transform: translate(-50%, -50%);"
        ></div>
      </div>
      <div>
        <HardChart
          :chartId="chartId"
          :chartName="chartName"
          @ChangeDateTimeSelect="ChangeDateTimeSelect"
          :isShowDatePicker="false"
        ></HardChart>
      </div>
    </div>

    <div class="row" style="margin-top: 20px;">
      <div class="col-md-12">
        <deal-reports
          :attributeIds="attributesReportCheckedIds"
          :range="range"
          :isContainDealCancel="selectedStatOptions === statOptions.reportWithCancelStatus"
        ></deal-reports>
      </div>
    </div>
  </div>
</template>
